config/routes.rb
Rails.application.routes.draw do
  devise_for :admin_users, ActiveAdmin::Devise.config
  ActiveAdmin.routes(self)
  mount ForestLiana::Engine => '/forest'
	get 'home' => 'home#home', as: 'home'

	get 'alogin' => 'session#login'
	post 'alogin' => 'session#create'
	get 'alogout' => 'session#destroy'

	get 'register' => 'register#new'
	post 'signup' => 'register#create'
	get 'profile' => 'register#profile'
	get 'edit' => 'register#edit'
	post 'edit' => 'register#update'
	get 'epass' => 'register#epass'
	post 'epass' => 'register#uppass'

	get 'login' => 'login#new'
	post 'login' => 'login#create'
	get 'logout' => 'login#destroy'

	get 'gindex' => 'galon#index'
	get 'gform' => 'galon#new'
	post 'gsave' => 'galon#create'

	get 'tindex' => 'tangki#index'
	get 'tform' => 'tangki#new'
	post 'tsave' => 'tangki#create'

	resources :galon, :only => [:show]

	resources :tangki, :only => [:show]

	root 'home#home'
end

app/models/admin_user.rb
class AdminUser < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, 
         :recoverable, :rememberable, :validatable
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/galon.rb
class Galon < ApplicationRecord
	validates :jgalon, presence: true, :numericality => {:only_integer => true}
	validates :telp, presence: true, :numericality => {:only_integer => true}
	validates :alamat, presence: true
	def sub_total
    sum = jgalon * 5000
    end
end

app/models/tangki.rb
class Tangki < ApplicationRecord
	validates :liter, presence: true
	validates :telp, presence: true, :numericality => {:only_integer => true}
	validates :alamat, presence: true
	def sub_total
    sum = liter * 70000
    end
end

app/models/user.rb
class User < ApplicationRecord
	has_secure_password
	validates :fnama, presence: true
    validates :nama, presence: true
    validates :telp, presence: true, :numericality => {:only_integer => true}
    validates :alamat, presence: true
    validates :password, confirmation: true, length: { minimum: 8 }
end

app/controllers/galon_controller.rb
class GalonController < ApplicationController
	def index
		@galons = Galon.all
	end

	def show
		@galond = Galon.find(params[:id])
	end

	def new
		@galon = Galon.new
	end

	def create
		@galon = Galon.new(galon_params)
		if @galon.save
			redirect_to @galon
		else
			redirect_to '/gform'
		end
	end

	private
	def galon_params
		params.require(:galon).permit(:jgalon, :telp, :alamat)
	end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
	def home
	end
end

app/controllers/login_controller.rb
class LoginController < ApplicationController
	def create
		user = User.find_by_nama(params[:nama])
		if user && user.authenticate(params[:password])
			session[:user_id] = user.id
			redirect_to '/'
		else
			redirect_to '/login'
		end
	end

	def destroy
		session[:user_id] = nil
		redirect_to '/login'
	end
end

app/controllers/pgalon_controller.rb
class PgalonController < ApplicationController
	def gkonfirm
		@galon = Galon.find(params[:id])
	end

	def gconfirm
		pgalon = Pgalon.new(pgalon_params)
		if pgalon.save
			redirect_to '/gstatus'
		else
			redirect_to '/gkonfirm'
		end
	end

	def status
		@pgalon = current_pgalon
	end

	private
	def pgalon_params
		params.require(:pgalon).permit(:gid, :harga)
	end
end

app/controllers/register_controller.rb
class RegisterController < ApplicationController
	def new
	end

	def create
    user = User.new(user_params)
    if user.save
      session[:user_id] = user.id
      redirect_to '/'
    else
      redirect_to '/register'
    end
  end

  def profile
    @user = current_user
  end

  def edit
    @user = current_user
  end
  
  def update
    @user = current_user
    if @user.update_attributes(user_params)
      redirect_to '/profile'
    else
      render 'edit'
    end
  end

  def epass
    @user = current_user
  end

  def uppass
    @user = current_user
    if @user.update_attributes(pass_params)
      redirect_to '/'
    else
      render 'epass'
    end
  end

  private
  def user_params
    params.require(:user).permit(:fnama, :nama, :telp, :alamat, :password, :password_confirmation)
  end

  def profile_params
    params.require(:user).permit(:fnama, :nama, :telp, :alamat)
  end

  def pass_params
    params.require(:user).permit(:password, :password_confirmation)
  end
end

app/controllers/tangki_controller.rb
class TangkiController < ApplicationController
	def index
		@tangkis = Tangki.all
	end

	def show
		@tangkid = Tangki.find(params[:id])
	end
	
	def new
		@tangki = Tangki.new
	end

	def create
		@tangki = Tangki.new(tangki_params)
		if @tangki.save
			redirect_to @tangki
		else
			redirect_to '/tform'
		end
	end

	private
	def tangki_params
		params.require(:tangki).permit(:liter, :telp, :alamat)
	end
end

app/helpers/about_helper.rb
module AboutHelper
end

app/helpers/admin_helper.rb
module AdminHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/galon_helper.rb
module GalonHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/login_helper.rb
module LoginHelper
end

app/helpers/pgalon_helper.rb
module PgalonHelper
end

app/helpers/ptangki_helper.rb
module PtangkiHelper
end

app/helpers/register_helper.rb
module RegisterHelper
end

app/helpers/session_helper.rb
module SessionHelper
end

app/helpers/tangki_helper.rb
module TangkiHelper
end

app/views/register/_error.html.erb
<style>
	#error_explanation {
		color: #f00;
		ul {
			list-style: none;
			margin: 0 0 18px 0;
		}
	}

	.field_with_errors {
		@extend .has-error;
	}
</style>

<% if @user.errors.any? %>
<div id="error_explanation">
	<div class="alert alert-danger">
		The form contains <%= pluralize(@user.errors.count, "error") %>.
	</div>
	<ul>
		<% @user.errors.full_messages.each do |msg| %>
		<li><%= msg %></li>
		<% end %>
	</ul>
</div>
<% end %>

app/views/register/edit.html.erb
<% provide(:title, 'Edit Profil User') %>

<%= render 'menu' %>

<div class="row">
  <div class="col-md-6 col-md-offset-3">

    <%= form_for :user do |f| %>

      <%= render 'error' %>
    
      <%= f.label :fnama, "Nama Lengkap" %>
      <%= f.text_field :fnama, class: 'form-control', :readonly => true%>
    
      <%= f.label :username, "Username" %>
      <%= f.text_field :nama, class: 'form-control', :readonly => true%>

      <%= f.label :telp, "Telepon" %>
      <%= f.text_field :telp, class: 'form-control' %>
    
      <%= f.label :alamat, "Alamat" %>
      <%= f.text_field :alamat, class: 'form-control' %>

      <%= f.label :password, "Password" %>
      <%= f.password_field :password, class: 'form-control' %>
    
      <%= f.label :password_confirmation, "Konfirmasi Password" %>
      <%= f.password_field :password_confirmation, class: 'form-control' %>

      <br>

      <%= f.submit "Simpan Data", class: "btn btn-primary" %>
      <a href="/profile" class="btn btn-danger"> Batal</a>
    <% end %>
  </div>
</div>

<%= render 'footer' %>

app/views/register/epass.html.erb
<% provide(:title, 'Edit Password User') %>

<%= render 'menu' %>

<div class="row">
  <div class="col-md-6 col-md-offset-3">

    <%= form_for :user do |f| %>

      <%= render 'error' %>
    
      <%= f.label :password, "Password" %>
      <%= f.password_field :password, class: 'form-control' %>
    
      <%= f.label :password_confirmation, "Konfirmasi Password" %>
      <%= f.password_field :password_confirmation, class: 'form-control' %>

      <br>

      <span class=""><%= f.submit "Simpan Password", class: "btn btn-primary" %></span>
      <a href="/profile" class="btn btn-danger"> Batal</a>
    <% end %>
    </div>
  </div>
</div>

<%= render 'footer' %>

app/views/register/new.html.erb
<style>
  .form-group input {
    margin: 0 .25rem;
    min-width: 125px;
    border: 1px solid #eee;
    border-left: 3px solid;
    border-radius: 5px;
    transition: border-color .5s ease-out;
  }
  .form-group input:optional {
    border-left-color: #999;
  }
  .form-group input:required:valid {
    border-left-color: palegreen;
  }
  .form-group input:invalid {
    border-left-color: salmon;
  }
</style>

<%= render 'menu' %>

<div class="row">
  <div class="col-lg-12">
    <div class="panel panel-default">
      <div class="card" style="background-color: lightgreen;">
        <div class="card-body">
          <div class="col-md-4 col-md-offset-4">
            <div class="panel panel-default">
              <div class="card">

                <form accept-charset="UTF-8" action="<%= signup_url %>" method="post">

                  <div style="margin:0;padding:0">
                    <input name="utf8" type="hidden" value="&#x2713;" />
                    <input name="authenticity_token" type="hidden" value="f755bb0ed134b76c432144748a6d4b7a7ddf2b71" />
                  </div>

                  <div class="card-header" style="background-color: lightblue;">
                    <h3 align="center"><strong>Register</strong></h3>
                    <hr>
                  </div>

                  <div class="card-body">
                    <div class="form-group">
                      <label for="fnama">Nama Lengkap</label>
                      <input type="text" name="user[fnama]" class="form-control" id="fnama" placeholder="Masukkan Nama Lengkap Anda" required>
                    </div>

                    <div class="form-group">
                      <label for="nama">Username</label>
                      <input type="text" name="user[nama]" class="form-control" id="nama" placeholder="Masukkan Username Anda" required>
                    </div>

                    <div class="form-group">
                      <label for="telp">Telepon</label>
                      <input type="text" name="user[telp]" pattern="[0-9]+" class="form-control" id="telp" placeholder="Masukkan No. Telepon Anda" required>
                    </div>

                    <div class="form-group">
                      <label for="alamat">Alamat</label>
                      <input type="text" name="user[alamat]" class="form-control" id="alamat" placeholder="Masukkan Alamat Anda" required>
                    </div>

                    <div class="form-group">
                      <label for="pass">Password</label>
                      <input type="password" name="user[password]" class="form-control" id="password" placeholder="Masukkan Password Anda (Minimal 8 karakter)" minlength="8" required>
                    </div>

                    <div class="form-group">
                      <label for="pass2">Konfirmasi Password</label>
                      <input type="password" name="user[password_confirmation]" class="form-control" id="password_confirmation" placeholder="Konfirmasi Password Anda" minlength="8" required>
                    </div>
                  </div>

                  <div class="card-footer">
                    <input name="submit" type="submit" value="Daftar" class="btn btn-primary btn-block">
                    <a href="/" class="btn btn-danger btn-block"> Batal</a>
                  </div>
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<%= render 'footer' %>

app/views/register/profile.html.erb
<%= render 'menu' %>

<div class="container">
	<div class="row">
		<h1><center><strong>Profil</center></strong></h1>
		<hr>
		<div class="panel panel-default">
			<div class="panel-body">

				<form class="form-horizontal" >
					<div class="form-group">
						<label class="control-label col-sm-3">Nama Lengkap:</label>
						<div class="col-sm-6">
							<label class="control-label"><%= @user.fnama %></label>
						</div>
					</div>

					<div class="form-group">
						<label class="control-label col-sm-3" for="telp">Username:</label>
						<div class="col-sm-6">
							<label class="control-label"><%= @user.nama %></label>
						</div>
					</div>

					<div class="form-group">
						<label class="control-label col-sm-3">Nomor Telepon:</label>
						<div class="col-sm-6">
							<label class="control-label"><%= @user.telp %></label>
						</div>
					</div>

					<div class="form-group">
						<label class="control-label col-sm-3">Alamat:</label>
						<div class="col-sm-6">
							<label class="control-label"><%= @user.alamat%></label>
						</div>
					</div>
				</form>
				<hr>
			</div>
		</div>
	</div>
</div>
<br>
<br>

<%= render 'footer' %>

app/views/register/show.html.erb
<%= render 'menu' %>

<%= render 'footer' %>